Index: vanHelsing/trunk/src/VanHelsing_types.py
===================================================================
--- vanHelsing/trunk/src/VanHelsing_types.py	(revision 837)
+++ vanHelsing/trunk/src/VanHelsing_types.py	(revision 839)
@@ -84,4 +84,46 @@
             self.pyclass = Holder
 
+    class ResourceAttributeType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
+        schema = "http://www.dass-it.de/VanHelsing/"
+        type = (schema, "ResourceAttributeType")
+        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
+            ns = ns0.ResourceAttributeType_Def.schema
+            TClist = [ZSI.TC.String(pname="key", aname="_key", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.String(pname="value", aname="_value", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            self.attribute_typecode_dict = attributes or {}
+            if extend: TClist += ofwhat
+            if restrict: TClist = ofwhat
+            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._key = None
+                    self._value = None
+                    return
+            Holder.__name__ = "ResourceAttributeType_Holder"
+            self.pyclass = Holder
+
+    class getResourceType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
+        schema = "http://www.dass-it.de/VanHelsing/"
+        type = (schema, "getResourceType")
+        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
+            ns = ns0.getResourceType_Def.schema
+            TClist = [ZSI.TCnumbers.Iint(pname="resId", aname="_resId", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.String(pname="director", aname="_director", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            self.attribute_typecode_dict = attributes or {}
+            if extend: TClist += ofwhat
+            if restrict: TClist = ofwhat
+            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._resId = None
+                    self._director = None
+                    return
+            Holder.__name__ = "getResourceType_Holder"
+            self.pyclass = Holder
+
     class listResources_Dec(ElementDeclaration):
         literal = "listResources"
@@ -114,3 +156,39 @@
             if self.pyclass is not None: self.pyclass.__name__ = "listResourcesResponse_Dec_Holder"
 
+    class getSimpleResource_Dec(ElementDeclaration):
+        literal = "getSimpleResource"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        substitutionGroup = None
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","getSimpleResource")
+            kw["aname"] = "_getSimpleResource"
+            if ns0.getResourceType_Def not in ns0.getSimpleResource_Dec.__bases__:
+                bases = list(ns0.getSimpleResource_Dec.__bases__)
+                bases.insert(0, ns0.getResourceType_Def)
+                ns0.getSimpleResource_Dec.__bases__ = tuple(bases)
+
+            ns0.getResourceType_Def.__init__(self, **kw)
+            if self.pyclass is not None: self.pyclass.__name__ = "getSimpleResource_Dec_Holder"
+
+    class getSimpleResourceResponse_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "getSimpleResourceResponse"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.getSimpleResourceResponse_Dec.schema
+            TClist = [GTD("http://www.dass-it.de/VanHelsing/","ResourceInfo",lazy=False)(pname="resInfo", aname="_resInfo", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="resAttribute", aname="_resAttribute", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","getSimpleResourceResponse")
+            kw["aname"] = "_getSimpleResourceResponse"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._resInfo = None
+                    self._resAttribute = []
+                    return
+            Holder.__name__ = "getSimpleResourceResponse_Holder"
+            self.pyclass = Holder
+
 # end class ns0 (tns: http://www.dass-it.de/VanHelsing/)