Index: vanHelsing/trunk/gui/WebContent/menu.jspx
===================================================================
--- vanHelsing/trunk/gui/WebContent/menu.jspx	(revision 857)
+++ vanHelsing/trunk/gui/WebContent/menu.jspx	(revision 858)
@@ -12,4 +12,5 @@
      <title>Van Helsing</title>
      <ice:outputStyle href="./xmlhttp/css/rime/rime.css" />
+     <ice:outputStyle href="./css/tree.css" />
      
     </head>
@@ -18,10 +19,16 @@
     <ice:form>
     <ice:panelGroup style="float:top">
+        <ice:commandButton id="newRes" 
+            value="create resource" 
+            actionListener="#{configurationBean.newResourceButtonListener}"/>
+		<ice:commandButton id="reloadRes"
+			value="reload Tree"
+			actionListener="#{configurationBean.reloadResourceButtonListener}" />
 		<ice:commandButton id="saveRes"
 	    	value="update resource"
 	        actionListener="#{configurationBean.saveButtonListener}"/>
-        <ice:commandButton id="newRes" 
-            value="create resource" 
-            actionListener="#{configurationBean.newResourceButtonListener}"/>
+		<ice:commandButton id="deleteRes"
+			value="delete resource"
+			actionListener="#{configurationBean.deleteResourceButtonListener}" />
  	</ice:panelGroup>
     
@@ -45,12 +52,12 @@
 		    			</f:facet>
 		    			<f:facet name="content">
-		    			<!-- <ice:panelGroup> -->
-							<!-- styleClass="selectedNode#{item.userObject eq treeController.selectedUserObject}"
-							style="display: inline" > -->
+		    			<ice:panelGroup  styleClass="selectedNode#{item.userObject.userObject.resId eq configurationBean.selectedId} selectedComponent#{item.userObject.selected}"
+							style="display:inline" > 
+
 						<ice:commandLink actionListener="#{configurationBean.userObjectItemNodeSelected}">
 		    				<f:param name="userObject.resId" value="#{item.userObject.userObject.resId}"/>
 		    			    <ice:outputText id="knoten" value="#{item.userObject.userObject.value}"/>
-		    			</ice:commandLink>
-		    			<!-- </ice:panelGroup> -->
+							</ice:commandLink>
+		    			</ice:panelGroup> 
 		    			</f:facet>
 		    		</ice:treeNode>
@@ -69,5 +76,6 @@
 				                         <ice:outputText value="Key" />
 				                 </f:facet>
-				                <ice:outputText value="#{item.key}" />
+				                <ice:outputText style="color:red" rendered="#{item.required eq true}" value="#{item.key}" />
+				                <ice:outputText style="color:green" rendered="#{item.required eq false}" value="#{item.key}" />
 				        </ice:column>
 				        <ice:column>
@@ -76,12 +84,18 @@
 				                </f:facet>
 				                <ice:inputText rendered="#{item.inputText != null}" partialSubmit="true" value="#{item.keyValue}" />
-								<ice:selectOneMenu id="KeyValue"
-									rendered="#{item.selectOneMenu != null}"
-                        			valueChangeListener="#{configurationBean.userObjectItemOptionSelected}"
-                        			value="#{item.keyValue}"
-                        			partialSubmit="true">
-                    				<f:selectItems id="KeyValueItems"
-                                   		value="#{item.keyValueList}"/>
-                				</ice:selectOneMenu>				                
+								<ice:panelGroup>
+									<ice:selectOneMenu id="KeyValue"
+										rendered="#{item.selectOneMenu != null}"
+	                        			valueChangeListener="#{configurationBean.userObjectItemOptionSelected}"
+	                        			value="#{item.keyValue}"
+	                        			partialSubmit="true">
+	                    				<f:selectItems id="KeyValueItems"
+	                                   		value="#{item.keyValueList}"/>
+	                				</ice:selectOneMenu>
+                					<ice:commandButton id="newRes" 
+							            value="+" 
+							            rendered="#{item.selectOneMenu != null}"
+							            actionListener="#{configurationBean.newResourceButtonListener}"/>
+                				</ice:panelGroup>				                
 				        </ice:column>
 				</ice:dataTable>