Index: vanHelsing/trunk/src/VanHelsing_types.py
===================================================================
--- vanHelsing/trunk/src/VanHelsing_types.py	(revision 855)
+++ vanHelsing/trunk/src/VanHelsing_types.py	(revision 861)
@@ -3,5 +3,5 @@
 #
 # schema types generated by "ZSI.generate.wsdl2python.WriteServiceModule"
-#    /usr/local/bin/wsdl2py -b VanHelsing.wsdl
+#    /home/tgoecke/ZSI-2.1-a1/scripts/wsdl2py --complexType /home/tgoecke/vanHelsing/trunk/src/VanHelsing.wsdl
 #
 ##################################################
@@ -84,4 +84,71 @@
             self.pyclass = Holder
 
+    class getResourceType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
+        schema = "http://www.dass-it.de/VanHelsing/"
+        type = (schema, "getResourceType")
+        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
+            ns = ns0.getResourceType_Def.schema
+            TClist = [ZSI.TCnumbers.Iint(pname="resId", aname="_resId", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.String(pname="director", aname="_director", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            self.attribute_typecode_dict = attributes or {}
+            if extend: TClist += ofwhat
+            if restrict: TClist = ofwhat
+            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._resId = None
+                    self._director = None
+                    return
+            Holder.__name__ = "getResourceType_Holder"
+            self.pyclass = Holder
+
+    class ResourceInitialization_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
+        schema = "http://www.dass-it.de/VanHelsing/"
+        type = (schema, "ResourceInitialization")
+        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
+            ns = ns0.ResourceInitialization_Def.schema
+            TClist = [GTD("http://www.dass-it.de/VanHelsing/","ResourceInfo",lazy=False)(pname="resInfo", aname="_resInfo", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.Boolean(pname="replace", aname="_replace", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="resAttribute", aname="_resAttribute", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded"))]
+            self.attribute_typecode_dict = attributes or {}
+            if extend: TClist += ofwhat
+            if restrict: TClist = ofwhat
+            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._resInfo = None
+                    self._replace = None
+                    self._resAttribute = []
+                    return
+            Holder.__name__ = "ResourceInitialization_Holder"
+            self.pyclass = Holder
+
+    class FileSetResource_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
+        schema = "http://www.dass-it.de/VanHelsing/"
+        type = (schema, "FileSetResource")
+        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
+            ns = ns0.FileSetResource_Def.schema
+            TClist = [ZSI.TC.Boolean(pname="replace", aname="_replace", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="parameters", aname="_parameters", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="options", aname="_options", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","fileSetInclude",lazy=False)(pname="include", aname="_include", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="exclude", aname="_exclude", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            self.attribute_typecode_dict = attributes or {}
+            if extend: TClist += ofwhat
+            if restrict: TClist = ofwhat
+            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._replace = None
+                    self._parameters = []
+                    self._options = []
+                    self._include = None
+                    self._exclude = None
+                    return
+            Holder.__name__ = "FileSetResource_Holder"
+            self.pyclass = Holder
+
     class ResourceAttributeType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
         schema = "http://www.dass-it.de/VanHelsing/"
@@ -105,23 +172,23 @@
             self.pyclass = Holder
 
-    class getResourceType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
-        schema = "http://www.dass-it.de/VanHelsing/"
-        type = (schema, "getResourceType")
-        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
-            ns = ns0.getResourceType_Def.schema
-            TClist = [ZSI.TCnumbers.Iint(pname="resId", aname="_resId", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.String(pname="director", aname="_director", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
-            self.attribute_typecode_dict = attributes or {}
-            if extend: TClist += ofwhat
-            if restrict: TClist = ofwhat
-            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
-            class Holder:
-                __metaclass__ = pyclass_type
-                typecode = self
-                def __init__(self):
-                    # pyclass
-                    self._resId = None
-                    self._director = None
-                    return
-            Holder.__name__ = "getResourceType_Holder"
+    class fileSetInclude_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
+        schema = "http://www.dass-it.de/VanHelsing/"
+        type = (schema, "fileSetInclude")
+        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
+            ns = ns0.fileSetInclude_Def.schema
+            TClist = [GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="fileList", aname="_fileList", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="options", aname="_options", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded"))]
+            self.attribute_typecode_dict = attributes or {}
+            if extend: TClist += ofwhat
+            if restrict: TClist = ofwhat
+            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._fileList = []
+                    self._options = []
+                    return
+            Holder.__name__ = "fileSetInclude_Holder"
             self.pyclass = Holder
 
@@ -192,24 +259,18 @@
             self.pyclass = Holder
 
-    class setSimpleResource_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+    class setSimpleResource_Dec(ElementDeclaration):
         literal = "setSimpleResource"
         schema = "http://www.dass-it.de/VanHelsing/"
-        def __init__(self, **kw):
-            ns = ns0.setSimpleResource_Dec.schema
-            TClist = [GTD("http://www.dass-it.de/VanHelsing/","ResourceInfo",lazy=False)(pname="resInfo", aname="_resInfo", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.dass-it.de/VanHelsing/","ResourceAttributeType",lazy=False)(pname="resAttribute", aname="_resAttribute", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded"))]
+        substitutionGroup = None
+        def __init__(self, **kw):
             kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setSimpleResource")
             kw["aname"] = "_setSimpleResource"
-            self.attribute_typecode_dict = {}
-            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
-            class Holder:
-                __metaclass__ = pyclass_type
-                typecode = self
-                def __init__(self):
-                    # pyclass
-                    self._resInfo = None
-                    self._resAttribute = []
-                    return
-            Holder.__name__ = "setSimpleResource_Holder"
-            self.pyclass = Holder
+            if ns0.ResourceInitialization_Def not in ns0.setSimpleResource_Dec.__bases__:
+                bases = list(ns0.setSimpleResource_Dec.__bases__)
+                bases.insert(0, ns0.ResourceInitialization_Def)
+                ns0.setSimpleResource_Dec.__bases__ = tuple(bases)
+
+            ns0.ResourceInitialization_Def.__init__(self, **kw)
+            if self.pyclass is not None: self.pyclass.__name__ = "setSimpleResource_Dec_Holder"
 
     class setSimpleResourceResponse_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
@@ -218,5 +279,5 @@
         def __init__(self, **kw):
             ns = ns0.setSimpleResourceResponse_Dec.schema
-            TClist = [ZSI.TCnumbers.Iint(pname="resId", aname="_resId", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.String(pname="status", aname="_status", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            TClist = [ZSI.TC.String(pname="status", aname="_status", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
             kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setSimpleResourceResponse")
             kw["aname"] = "_setSimpleResourceResponse"
@@ -228,8 +289,320 @@
                 def __init__(self):
                     # pyclass
+                    self._status = None
+                    return
+            Holder.__name__ = "setSimpleResourceResponse_Holder"
+            self.pyclass = Holder
+
+    class deleteResourceFault_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "deleteResourceFault"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.deleteResourceFault_Dec.schema
+            TClist = [ZSI.TC.String(pname="deleteResourceFault", aname="_deleteResourceFault", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","deleteResourceFault")
+            kw["aname"] = "_deleteResourceFault"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._deleteResourceFault = None
+                    return
+            Holder.__name__ = "deleteResourceFault_Holder"
+            self.pyclass = Holder
+
+    class deleteResourceFault1_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "deleteResourceFault1"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.deleteResourceFault1_Dec.schema
+            TClist = [ZSI.TC.String(pname="deleteResourceFault1", aname="_deleteResourceFault1", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","deleteResourceFault1")
+            kw["aname"] = "_deleteResourceFault1"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._deleteResourceFault1 = None
+                    return
+            Holder.__name__ = "deleteResourceFault1_Holder"
+            self.pyclass = Holder
+
+    class invalidId_Dec(ZSI.TC.String, ElementDeclaration):
+        literal = "invalidId"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","invalidId")
+            kw["aname"] = "_invalidId"
+            class IHolder(str): typecode=self
+            kw["pyclass"] = IHolder
+            IHolder.__name__ = "_invalidId_immutable_holder"
+            ZSI.TC.String.__init__(self, **kw)
+
+    class constraintViolation_Dec(ZSI.TC.String, ElementDeclaration):
+        literal = "constraintViolation"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","constraintViolation")
+            kw["aname"] = "_constraintViolation"
+            class IHolder(str): typecode=self
+            kw["pyclass"] = IHolder
+            IHolder.__name__ = "_constraintViolation_immutable_holder"
+            ZSI.TC.String.__init__(self, **kw)
+
+    class syntaxError_Dec(ZSI.TC.String, ElementDeclaration):
+        literal = "syntaxError"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","syntaxError")
+            kw["aname"] = "_syntaxError"
+            class IHolder(str): typecode=self
+            kw["pyclass"] = IHolder
+            IHolder.__name__ = "_syntaxError_immutable_holder"
+            ZSI.TC.String.__init__(self, **kw)
+
+    class createSimpleResource_Dec(ElementDeclaration):
+        literal = "createSimpleResource"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        substitutionGroup = None
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","createSimpleResource")
+            kw["aname"] = "_createSimpleResource"
+            if ns0.ResourceInitialization_Def not in ns0.createSimpleResource_Dec.__bases__:
+                bases = list(ns0.createSimpleResource_Dec.__bases__)
+                bases.insert(0, ns0.ResourceInitialization_Def)
+                ns0.createSimpleResource_Dec.__bases__ = tuple(bases)
+
+            ns0.ResourceInitialization_Def.__init__(self, **kw)
+            if self.pyclass is not None: self.pyclass.__name__ = "createSimpleResource_Dec_Holder"
+
+    class createSimpleResourceResponse_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "createSimpleResourceResponse"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.createSimpleResourceResponse_Dec.schema
+            TClist = [ZSI.TCnumbers.Iint(pname="resId", aname="_resId", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","createSimpleResourceResponse")
+            kw["aname"] = "_createSimpleResourceResponse"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
                     self._resId = None
+                    return
+            Holder.__name__ = "createSimpleResourceResponse_Holder"
+            self.pyclass = Holder
+
+    class createSimpleResourceFault_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "createSimpleResourceFault"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.createSimpleResourceFault_Dec.schema
+            TClist = [ZSI.TC.String(pname="createSimpleResourceFault", aname="_createSimpleResourceFault", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","createSimpleResourceFault")
+            kw["aname"] = "_createSimpleResourceFault"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._createSimpleResourceFault = None
+                    return
+            Holder.__name__ = "createSimpleResourceFault_Holder"
+            self.pyclass = Holder
+
+    class deleteResource_Dec(ElementDeclaration):
+        literal = "deleteResource"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        substitutionGroup = None
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","deleteResource")
+            kw["aname"] = "_deleteResource"
+            if ns0.ResourceInfo_Def not in ns0.deleteResource_Dec.__bases__:
+                bases = list(ns0.deleteResource_Dec.__bases__)
+                bases.insert(0, ns0.ResourceInfo_Def)
+                ns0.deleteResource_Dec.__bases__ = tuple(bases)
+
+            ns0.ResourceInfo_Def.__init__(self, **kw)
+            if self.pyclass is not None: self.pyclass.__name__ = "deleteResource_Dec_Holder"
+
+    class setFileSetResource_Dec(ElementDeclaration):
+        literal = "setFileSetResource"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        substitutionGroup = None
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setFileSetResource")
+            kw["aname"] = "_setFileSetResource"
+            if ns0.FileSetResource_Def not in ns0.setFileSetResource_Dec.__bases__:
+                bases = list(ns0.setFileSetResource_Dec.__bases__)
+                bases.insert(0, ns0.FileSetResource_Def)
+                ns0.setFileSetResource_Dec.__bases__ = tuple(bases)
+
+            ns0.FileSetResource_Def.__init__(self, **kw)
+            if self.pyclass is not None: self.pyclass.__name__ = "setFileSetResource_Dec_Holder"
+
+    class setFileSetResourceResponse_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "setFileSetResourceResponse"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.setFileSetResourceResponse_Dec.schema
+            TClist = [ZSI.TC.String(pname="status", aname="_status", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setFileSetResourceResponse")
+            kw["aname"] = "_setFileSetResourceResponse"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
                     self._status = None
                     return
-            Holder.__name__ = "setSimpleResourceResponse_Holder"
+            Holder.__name__ = "setFileSetResourceResponse_Holder"
+            self.pyclass = Holder
+
+    class createFileSetResource_Dec(ElementDeclaration):
+        literal = "createFileSetResource"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        substitutionGroup = None
+        def __init__(self, **kw):
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","createFileSetResource")
+            kw["aname"] = "_createFileSetResource"
+            if ns0.FileSetResource_Def not in ns0.createFileSetResource_Dec.__bases__:
+                bases = list(ns0.createFileSetResource_Dec.__bases__)
+                bases.insert(0, ns0.FileSetResource_Def)
+                ns0.createFileSetResource_Dec.__bases__ = tuple(bases)
+
+            ns0.FileSetResource_Def.__init__(self, **kw)
+            if self.pyclass is not None: self.pyclass.__name__ = "createFileSetResource_Dec_Holder"
+
+    class createFileSetResourceResponse_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "createFileSetResourceResponse"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.createFileSetResourceResponse_Dec.schema
+            TClist = [ZSI.TCnumbers.Iint(pname="resId", aname="_resId", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","createFileSetResourceResponse")
+            kw["aname"] = "_createFileSetResourceResponse"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._resId = None
+                    return
+            Holder.__name__ = "createFileSetResourceResponse_Holder"
+            self.pyclass = Holder
+
+    class setFileSetResourceFault_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "setFileSetResourceFault"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.setFileSetResourceFault_Dec.schema
+            TClist = [ZSI.TC.String(pname="setFileSetResourceFault", aname="_setFileSetResourceFault", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setFileSetResourceFault")
+            kw["aname"] = "_setFileSetResourceFault"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._setFileSetResourceFault = None
+                    return
+            Holder.__name__ = "setFileSetResourceFault_Holder"
+            self.pyclass = Holder
+
+    class setSimpleResourceFault_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "setSimpleResourceFault"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.setSimpleResourceFault_Dec.schema
+            TClist = [ZSI.TC.String(pname="setSimpleResourceFault", aname="_setSimpleResourceFault", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setSimpleResourceFault")
+            kw["aname"] = "_setSimpleResourceFault"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._setSimpleResourceFault = None
+                    return
+            Holder.__name__ = "setSimpleResourceFault_Holder"
+            self.pyclass = Holder
+
+    class setFileSetResourceFault1_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "setFileSetResourceFault1"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.setFileSetResourceFault1_Dec.schema
+            TClist = [ZSI.TC.String(pname="setFileSetResourceFault1", aname="_setFileSetResourceFault1", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setFileSetResourceFault1")
+            kw["aname"] = "_setFileSetResourceFault1"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._setFileSetResourceFault1 = None
+                    return
+            Holder.__name__ = "setFileSetResourceFault1_Holder"
+            self.pyclass = Holder
+
+    class createFileSetResourceFault_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "createFileSetResourceFault"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.createFileSetResourceFault_Dec.schema
+            TClist = [ZSI.TC.String(pname="createFileSetResourceFault", aname="_createFileSetResourceFault", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","createFileSetResourceFault")
+            kw["aname"] = "_createFileSetResourceFault"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._createFileSetResourceFault = None
+                    return
+            Holder.__name__ = "createFileSetResourceFault_Holder"
+            self.pyclass = Holder
+
+    class setSimpleResourceFault1_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
+        literal = "setSimpleResourceFault1"
+        schema = "http://www.dass-it.de/VanHelsing/"
+        def __init__(self, **kw):
+            ns = ns0.setSimpleResourceFault1_Dec.schema
+            TClist = [ZSI.TC.String(pname="setSimpleResourceFault1", aname="_setSimpleResourceFault1", minOccurs=1, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
+            kw["pname"] = ("http://www.dass-it.de/VanHelsing/","setSimpleResourceFault1")
+            kw["aname"] = "_setSimpleResourceFault1"
+            self.attribute_typecode_dict = {}
+            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
+            class Holder:
+                __metaclass__ = pyclass_type
+                typecode = self
+                def __init__(self):
+                    # pyclass
+                    self._setSimpleResourceFault1 = None
+                    return
+            Holder.__name__ = "setSimpleResourceFault1_Holder"
             self.pyclass = Holder
 