Index: obs_notify_generic/obs_notify_generic.pm
===================================================================
--- obs_notify_generic/obs_notify_generic.pm	(revision 1188)
+++ obs_notify_generic/obs_notify_generic.pm	(revision 1190)
@@ -48,6 +48,6 @@
     };
     if ( not $self->{'logfile'} ) {
+        ##$self->{'logfile'} = "/tmp/notify_generic.log";
         $self->{'logfile'} = "/srv/obs/log/notify_generic.log";
-        #$self->{'logfile'} = "/tmp/notify_generic.log";
     }
     bless $self, shift;
@@ -60,5 +60,5 @@
 
     $type = "UNKNOWN" unless $type;
-    
+
     my $cfg_type;
     if ( $self->{'cfg'}->{$type} ) {
@@ -75,7 +75,12 @@
             #print "key: $key\n";
             #print "value: $value\n";
-            if ( not( exists($paramRef->{$key}) ) ) {
-				error_msg( "$type (". Data::Dumper->new( [$paramRef] )->Indent(0)->Dump ."): filter for '". $key ."' is invalid" );
+            if ( not( exists( $paramRef->{$key} ) ) ) {
+                error_msg( "$type ("
+                      . Data::Dumper->new( [$paramRef] )->Indent(0)->Dump
+                      . "): filter for '"
+                      . $key
+                      . "' is invalid" );
                 $match = 0;
+
                 # exit loop
                 last;
@@ -88,23 +93,22 @@
             if ( $entry->{'action'} ) {
 
-                #print $entry->{'action'}, "\n";
                 if ( $paramRef->{'project'} ) {
-					my $project = $paramRef->{'project'};
-					$project =~ s/:/:\//g;
-					$paramRef->{'project_path'}="/srv/obs/repos/" . $project;
+                    my $project = $paramRef->{'project'};
+                    $project =~ s/:/:\//g;
+                    $paramRef->{'project_path'} = "/srv/obs/repos/" . $project;
                 }
-                # create regex, 
+
+                # create regex,
                 # test against longest string first to avoid partial replacement ($repo, $repository)
-                my $check = join '|', sort { 
-                        length($b) <=> length($a)
-                    } keys %{$paramRef};
+                my $check = join '|',
+                  sort { length($b) <=> length($a) } keys %{$paramRef};
                 my $action = $entry->{'action'};
                 $action =~ s/\$($check)/$paramRef->{$1}/g;
 
-				$extra = {
-					'action_template' => $entry->{'action'},
-					'action'          => $action,
-				};
-                
+                $extra = {
+                    'action_template' => $entry->{'action'},
+                    'action'          => $action,
+                };
+
                 #$self->run_wait( $action, $extra );
                 $self->run_daemon( $action, $extra );
@@ -124,30 +128,27 @@
     my ( $self, $action, $extra ) = @_;
 
-	#print $action, "\n";
-	my $in = undef;
-	my $out;
-	my $err;
-	my $rc;
-	eval {
-		my $process =
-			IPC::Run::start( [ "sh", "--login", "-c", "HOME=/usr/lib/obs $action", "2>&1" ],
-			\$in, \$out, \$err );
-		$process->finish();
-		$rc = $process->result(0);
-	};
-	if ($@) {
-
-		#print "eval: ", $@;
-		$out = join( "\n", $@ );
-		$rc = 127;
-	}
-
-	#print "rc:  ", $rc, "\n";
-	#print "out: ", $out, "\n";
-	chomp($out);
-
-	#print "err: ", $err, "\n";
-	$extra->{'returncode'} = $rc;
-	$extra->{'output'} = $out;
+    my $in = undef;
+    my $out;
+    my $err;
+    my $rc;
+    eval {
+        my $process =
+          IPC::Run::start(
+            [ "sh", "--login", "-c", "HOME=/usr/lib/obs $action", "2>&1" ],
+            \$in, \$out, \$err );
+        $process->finish();
+        $rc = $process->result(0);
+    };
+    if ($@) {
+
+        #print "eval: ", $@;
+        $out = join( "\n", $@ );
+        $rc = 127;
+    }
+
+    chomp($out);
+
+    $extra->{'returncode'} = $rc;
+    $extra->{'output'}     = $out;
 }
 
@@ -156,13 +157,15 @@
     my ( $self, $action, $extra ) = @_;
 
-    my $daemon=Proc::Daemon->new();
-    my $pid=$daemon->Init( {
-            exec_command => "date --rfc-3339=seconds; echo '$action'; $action", 
-            child_STDOUT => "+>>" . $self->{'logfile'} . ".out.log", 
+    my $daemon = Proc::Daemon->new();
+    my $pid    = $daemon->Init(
+        {
+            exec_command => "date --rfc-3339=seconds; echo '$action'; $action",
+            child_STDOUT => "+>>" . $self->{'logfile'} . ".out.log",
             child_STDERR => "+>>" . $self->{'logfile'} . ".out.log",
-        } );
-
-    #print $daemon->Status($pid);  
-        
+        }
+    );
+
+    #print $daemon->Status($pid);
+
     $extra->{'pid'} = $pid;
 }
@@ -193,5 +196,5 @@
 
     print $fh localtime->strftime("%Y%m%d %H%M%S"), " TYPE=$type";
-    
+
     if ($extra) {
         print $fh "\n";